diff --git a/src/odbc/unittests/rpc.c b/src/odbc/unittests/rpc.c
index 3b58e29..7027df1 100644
--- a/src/odbc/unittests/rpc.c
+++ b/src/odbc/unittests/rpc.c
@@ -6,7 +6,7 @@
 #include "common.h"
 #include <assert.h>
 
-static char software_version[] = "$Id: rpc.c,v 1.10 2008/02/08 08:31:19 freddy77 Exp $";
+static char software_version[] = "$Id: rpc.c,v 1.11 2008/11/04 10:59:02 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static const char procedure_sql[] = 
@@ -41,10 +41,7 @@ init_proc(const char *name)
 		printf("Dropping procedure %s\n", name);
 		sprintf(cmd, "if exists (select 1 from sysobjects where name = '%s' and type = 'P') "
 				"DROP PROCEDURE %s", name, name);
-		if (!SQL_SUCCEEDED(SQLExecDirect(Statement, (SQLCHAR *) cmd, SQL_NTS))) {
-			CheckReturn();
-			exit(1);
-		}
+		CHKExecDirect((SQLCHAR *) cmd, SQL_NTS, "SI");
 	}
 
 	printf("Creating procedure %s\n", name);
@@ -65,10 +62,8 @@ static void
 Test(const char *name)
 {
 	int iresults=0, data_errors=0;
-	unsigned char sqlstate[6], msg[256];
-	SQLRETURN erc;
 	int ipar=0;
-	HSTMT stmt;
+	HSTMT Statement = SQL_NULL_HSTMT;
 	char call_cmd[128];
 	struct Argument { 
                 SQLSMALLINT       InputOutputType;  /* fParamType */
@@ -97,7 +92,7 @@ Test(const char *name)
 
 
 	printf("executing SQLAllocStmt\n");
-	CHK(SQLAllocStmt, (Connection, &stmt));
+	CHKAllocStmt(&Statement, "S");
 
 	for( ipar=0; ipar < sizeof(args)/sizeof(args[0]); ipar++ ) {
 		printf("executing SQLBindParameter for parameter %d\n", 1+ipar);
@@ -107,7 +102,7 @@ Test(const char *name)
 			memset(args[ipar].ParameterValuePtr, 0, args[ipar].BufferLength);
 			memset(args[ipar].ParameterValuePtr, 'a', args[ipar].BufferLength - 1);
 		}
-		CHK(SQLBindParameter,	( stmt, 1+ipar
+		CHKBindParameter	( 1+ipar
 					, args[ipar].InputOutputType
 					, args[ipar].ValueType
 					, args[ipar].ParameterType
@@ -116,19 +111,16 @@ Test(const char *name)
 					, args[ipar].ParameterValuePtr
 					, args[ipar].BufferLength
 					, &args[ipar].ind
-					));
+					, "S"
+					);
 	}
 
 	sprintf(call_cmd, "{?=call %s(?,?,?,?,?)}", name );
 	printf("executing SQLPrepare: %s\n", call_cmd);
-	CHK(SQLPrepare, (stmt, (SQLCHAR *) call_cmd, SQL_NTS));
+	CHKPrepare((SQLCHAR *) call_cmd, SQL_NTS, "S");
 
 	printf("executing SQLExecute\n");
-	if (! SQL_SUCCEEDED(SQLExecute(stmt))) {
-		erc = SQLGetDiagRec(SQL_HANDLE_STMT, stmt, 1, sqlstate, NULL, msg, sizeof(msg), NULL);
-		fprintf(stderr, "SQL error %s -- %s\n", sqlstate, msg);
-		ODBC_REPORT_ERROR("Unable to execute SQLExecute\n");
-	}
+	CHKExecute("SI");
 
 	do {
 		static const char dashes[] = "------------------------------";
@@ -141,7 +133,7 @@ Test(const char *name)
 		SQLSMALLINT  nullable;
 
 		printf("executing SQLNumResultCols for result set %d\n", ++iresults);
-		CHK(SQLNumResultCols, (stmt,  &ncols));
+		CHKNumResultCols(&ncols, "S");
 
 		printf("executing SQLDescribeCol for %d column%c\n", ncols, (ncols == 1? ' ' : 's'));
 		printf("%-5.5s %-15.15s %5.5s %5.5s %5.5s %8.8s\n", "col", "name", "type", "size", "scale", "nullable"); 
@@ -149,34 +141,28 @@ Test(const char *name)
 		
 		for (icol=ncols; icol > 0; icol--) {
 			SQLULEN size;
-			CHK(SQLDescribeCol, (stmt, icol, name, sizeof(name),
-						    &namelen, &type, &size, &scale, &nullable));
+			CHKDescribeCol(icol, name, sizeof(name),
+				       &namelen, &type, &size, &scale, &nullable, "S");
 			printf("%-5d %-15s %5d %5ld %5d %8c\n", icol, name, type, (long int)size, scale, (nullable? 'Y' : 'N')); 
 		}
 
 		printf("executing SQLFetch...\n");
 		printf("\t%-30s\n\t%s\n", name, dashes);
-		for (nrows=0; (erc = SQLFetch(stmt)) == SQL_SUCCESS; nrows++) {
+		for (nrows=0; CHKFetch("SNo") == SQL_SUCCESS; nrows++) {
 			const SQLINTEGER icol = 1;
 			char buf[60];
 			SQLLEN len;
-			erc = SQLGetData( stmt
-					, icol
+			CHKGetData( icol
 					, SQL_C_CHAR	/* fCType */
 					, buf		/* rgbValue */
 					, sizeof(buf)	/* cbValueMax */
 	                		, &len		/* pcbValue */	
+					, "SI"
 					);
 			printf("\t%-30s\t(%2d bytes)\n", buf, (int) len);
 		}
+		printf("done.\n");
 
-		if (erc != SQL_NO_DATA_FOUND) {
-			erc = SQLGetDiagRec(SQL_HANDLE_STMT, stmt, 1, sqlstate, NULL, msg, sizeof(msg), NULL);
-			fprintf(stderr, "SQL error %s -- %s\n", sqlstate, msg);
-			ODBC_REPORT_ERROR("Unable to execute SQLFetch\n");
-		} else {
-			printf("done.\n");
-		}
 		switch (iresults) {
 		case 1:
 			printf("0 rows expected, %d found\n", nrows);
@@ -193,13 +179,8 @@ Test(const char *name)
 		}
 
 		printf("executing SQLMoreResults...\n");
-	} while ((erc = SQLMoreResults(stmt)) == SQL_SUCCESS);
-
-	if (erc != SQL_NO_DATA_FOUND) {
-		ODBC_REPORT_ERROR("Unable to execute SQLMoreResults\n");
-	} else {
-		printf("done.\n");
-	}
+	} while (CHKMoreResults("SNo") == SQL_SUCCESS);
+	printf("done.\n");
 
 	for( ipar=0; ipar < sizeof(args)/sizeof(args[0]); ipar++ ) {
 		if (args[ipar].InputOutputType == SQL_PARAM_INPUT)
@@ -220,7 +201,8 @@ Test(const char *name)
 	}
 
 	printf("executing SQLFreeStmt\n");
-	CHK(SQLFreeStmt, (stmt, SQL_DROP));
+	CHKFreeStmt(SQL_DROP, "S");
+	Statement = SQL_NULL_HSTMT;
 
 	for (ipar = 0; ipar < sizeof(args)/sizeof(args[0]); ++ipar)
 		if (args[ipar].BufferLength > 0)
diff --git a/src/odbc/unittests/scroll.c b/src/odbc/unittests/scroll.c
index f3ff03f..b5dc2a6 100644
--- a/src/odbc/unittests/scroll.c
+++ b/src/odbc/unittests/scroll.c
@@ -2,7 +2,7 @@
 
 /* Test cursors */
 
-static char software_version[] = "$Id: scroll.c,v 1.7 2008/01/29 14:30:48 freddy77 Exp $";
+static char software_version[] = "$Id: scroll.c,v 1.8 2008/11/04 10:59:02 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 int
@@ -45,6 +45,7 @@ main(int argc, char *argv[])
 	use_odbc_version3 = 1;
 
 	Connect();
+	CheckCursor();
 
 	/* create test table */
 	Command(Statement, "IF OBJECT_ID('tempdb..#test') IS NOT NULL DROP TABLE #test");
@@ -57,34 +58,19 @@ main(int argc, char *argv[])
 
 	/* set cursor options */
 	ResetStatement();
-	retcode = SQLSetStmtAttr(Statement, SQL_ATTR_CONCURRENCY, (SQLPOINTER) SQL_CONCUR_ROWVER, 0);
-	if (retcode != SQL_SUCCESS) {
-		char output[256];
-		unsigned char sqlstate[6];
-
-		CHK(SQLGetDiagRec, (SQL_HANDLE_STMT, Statement, 1, sqlstate, NULL, (SQLCHAR *) output, sizeof(output), NULL));
-		sqlstate[5] = 0;
-		if (strcmp((const char*) sqlstate, "01S02") == 0) {
-			printf("Your connection seems to not support cursors, probably you are using wrong protocol version or Sybase\n");
-			Disconnect();
-			exit(0);
-		}
-		ODBC_REPORT_ERROR("SQLSetStmtAttr");
-	}
-
-
-	CHK(SQLSetStmtAttr, (Statement, SQL_ATTR_CURSOR_SCROLLABLE, (SQLPOINTER) SQL_SCROLLABLE, 0));
-	CHK(SQLSetStmtAttr, (Statement, SQL_ATTR_CURSOR_TYPE, (SQLPOINTER) SQL_CURSOR_DYNAMIC, 0));
-	CHK(SQLSetStmtAttr, (Statement, SQL_ATTR_ROW_ARRAY_SIZE, (SQLPOINTER) ROWS, 0));
-	CHK(SQLSetStmtAttr, (Statement, SQL_ATTR_ROW_STATUS_PTR, (SQLPOINTER) statuses, 0));
-	CHK(SQLSetStmtAttr, (Statement, SQL_ATTR_ROWS_FETCHED_PTR, &num_row, 0));
+	CHKSetStmtAttr(SQL_ATTR_CONCURRENCY, (SQLPOINTER) SQL_CONCUR_ROWVER, 0, "S");
+	CHKSetStmtAttr(SQL_ATTR_CURSOR_SCROLLABLE, (SQLPOINTER) SQL_SCROLLABLE, 0, "S");
+	CHKSetStmtAttr(SQL_ATTR_CURSOR_TYPE, (SQLPOINTER) SQL_CURSOR_DYNAMIC, 0, "S");
+	CHKSetStmtAttr(SQL_ATTR_ROW_ARRAY_SIZE, (SQLPOINTER) ROWS, 0, "S");
+	CHKSetStmtAttr(SQL_ATTR_ROW_STATUS_PTR, (SQLPOINTER) statuses, 0, "S");
+	CHKSetStmtAttr(SQL_ATTR_ROWS_FETCHED_PTR, &num_row, 0, "S");
 
 	/* */
-	CHK(SQLExecDirect, (Statement, (SQLCHAR *) "SELECT i, c FROM #test", SQL_NTS));
+	CHKExecDirect((SQLCHAR *) "SELECT i, c FROM #test", SQL_NTS, "S");
 
 	/* bind some rows at a time */
-	CHK(SQLBindCol, (Statement, 1, SQL_C_ULONG, n, 0, n_len));
-	CHK(SQLBindCol, (Statement, 2, SQL_C_CHAR, c, C_LEN, c_len));
+	CHKBindCol(1, SQL_C_ULONG, n, 0, n_len, "S");
+	CHKBindCol(2, SQL_C_CHAR, c, C_LEN, c_len, "S");
 
 	for (i_test = 0; i_test < num_tests; ++i_test) {
 		const TEST *t = &tests[i_test];
diff --git a/src/odbc/unittests/t0001.c b/src/odbc/unittests/t0001.c
index a51adea..5b4e160 100644
--- a/src/odbc/unittests/t0001.c
+++ b/src/odbc/unittests/t0001.c
@@ -1,13 +1,12 @@
 #include "common.h"
 
-static char software_version[] = "$Id: t0001.c,v 1.16 2008/02/08 09:28:04 freddy77 Exp $";
+static char software_version[] = "$Id: t0001.c,v 1.17 2008/11/04 10:59:02 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 int
 main(int argc, char *argv[])
 {
 
-	int res;
 	int i;
 
 	SQLLEN cnamesize;
@@ -23,40 +22,28 @@ main(int argc, char *argv[])
 		"col1 varchar(30) not null,"
 		"col2 int not null,"
 		"col3 float not null," "col4 numeric(18,6) not null," "col5 datetime not null," "col6 text not null)";
-	CHK(CommandWithResult, (Statement, command));
+	Command(Statement, command);
 
 	command = "insert #odbctestdata values ("
 		"'ABCDEFGHIJKLMNOP',"
 		"123456," "1234.56," "123456.78," "'Sep 11 2001 10:00AM'," "'just to check returned length...')";
-	CHK(CommandWithResult, (Statement, command));
+	Command(Statement, command);
 
-	CHK(CommandWithResult, (Statement, "select * from #odbctestdata"));
+	Command(Statement, "select * from #odbctestdata");
 
-	res = SQLFetch(Statement);
-	if (res != SQL_SUCCESS && res != SQL_SUCCESS_WITH_INFO) {
-		fprintf(stderr, "Unable to fetch row\n");
-		CheckReturn();
-	}
+	CHKFetch("SI");
 
 	for (i = 1; i <= 6; i++) {
-		CHK(SQLGetData, (Statement, i, SQL_C_CHAR, output, sizeof(output), &cnamesize));
+		CHKGetData(i, SQL_C_CHAR, output, sizeof(output), &cnamesize, "S");
 
 		printf("output data >%s< len_or_ind = %d\n", output, (int) cnamesize);
 		if (cnamesize != strlen((char *) output))
 			return 1;
 	}
 
-	res = SQLFetch(Statement);
-	if (res != SQL_NO_DATA) {
-		fprintf(stderr, "Unable to fetch row\n");
-		CheckReturn();
-	}
+	CHKFetch("No");
 
-	res = SQLCloseCursor(Statement);
-	if (!SQL_SUCCEEDED(res)) {
-		fprintf(stderr, "Unable to close cursor\n");
-		CheckReturn();
-	}
+	CHKCloseCursor("SI");
 
 	Command(Statement, "drop table #odbctestdata");
 
diff --git a/src/odbc/unittests/t0002.c b/src/odbc/unittests/t0002.c
index af7cfc3..120b515 100644
--- a/src/odbc/unittests/t0002.c
+++ b/src/odbc/unittests/t0002.c
@@ -1,14 +1,12 @@
 #include "common.h"
 
-static char software_version[] = "$Id: t0002.c,v 1.14 2008/02/08 09:28:04 freddy77 Exp $";
+static char software_version[] = "$Id: t0002.c,v 1.15 2008/11/04 10:59:02 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 int
 main(int argc, char *argv[])
 {
-
-	int res;
-	HSTMT stmt;
+	HSTMT old_Statement;
 
 	Connect();
 
@@ -22,44 +20,27 @@ main(int argc, char *argv[])
 	 * then make another query with first select and drop this statement
 	 * result should not disappear (required for DBD::ODBC)
 	 */
+	old_Statement = Statement;
+	Statement = SQL_NULL_HSTMT;
+	CHKAllocStmt(&Statement, "S");
 
-	CHK(SQLAllocStmt, (Connection, &stmt));
-
-	Command(stmt, "select * from #odbctestdata where 0=1");
+	Command(Statement, "select * from #odbctestdata where 0=1");
 
-	if (SQLFetch(stmt) != SQL_NO_DATA) {
-		fprintf(stderr, "Data not expected\n");
-		exit(1);
-	}
+	CHKFetch("No");
 
-	res = SQLCloseCursor(stmt);
-	if (!SQL_SUCCEEDED(res)) {
-		fprintf(stderr, "Unable to close cursor\n");
-		CheckReturn();
-	}
+	CHKCloseCursor("SI");
 
-	Command(Statement, "select * from #odbctestdata");
+	Command(old_Statement, "select * from #odbctestdata");
 
 	/* drop first statement .. data should not disappear */
-	CHK(SQLFreeStmt, (stmt, SQL_DROP));
-
-	res = SQLFetch(Statement);
-	if (res != SQL_SUCCESS && res != SQL_SUCCESS_WITH_INFO) {
-		fprintf(stderr, "Unable to fetch row. Drop of previous statement discard results... bad!\n");
-		CheckReturn();
-	}
-
-	res = SQLFetch(Statement);
-	if (res != SQL_NO_DATA) {
-		fprintf(stderr, "Unable to fetch row\n");
-		CheckReturn();
-	}
-
-	res = SQLCloseCursor(Statement);
-	if (!SQL_SUCCEEDED(res)) {
-		fprintf(stderr, "Unable to close cursr\n");
-		CheckReturn();
-	}
+	CHKFreeStmt(SQL_DROP, "S");
+	Statement = old_Statement;
+
+	CHKFetch("SI");
+
+	CHKFetch("No");
+
+	CHKCloseCursor("SI");
 
 	Command(Statement, "drop table #odbctestdata");
 
diff --git a/src/odbc/unittests/t0003.c b/src/odbc/unittests/t0003.c
index d9e6640..8c5e115 100644
--- a/src/odbc/unittests/t0003.c
+++ b/src/odbc/unittests/t0003.c
@@ -2,7 +2,7 @@
 
 /* Test for SQLMoreResults */
 
-static char software_version[] = "$Id: t0003.c,v 1.17 2008/01/29 14:30:49 freddy77 Exp $";
+static char software_version[] = "$Id: t0003.c,v 1.18 2008/11/04 10:59:02 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static void
@@ -14,41 +14,36 @@ DoTest(int prepared)
 	if (!prepared) {
 		Command(Statement, "select * from #odbctestdata select * from #odbctestdata");
 	} else {
-		CHK(SQLPrepare, (Statement, (SQLCHAR *)"select * from #odbctestdata select * from #odbctestdata", SQL_NTS));
-		CHK(SQLExecute, (Statement));
+		CHKPrepare((SQLCHAR *)"select * from #odbctestdata select * from #odbctestdata", SQL_NTS, "S");
+		CHKExecute("S");
 	}
 
-	if (SQLFetch(Statement) != SQL_NO_DATA)
-		ODBC_REPORT_ERROR("Data not expected");
+	CHKFetch("No");
 
-	CHK(SQLMoreResults, (Statement));
+	CHKMoreResults("S");
 	printf("Getting next recordset\n");
 
-	if (SQLFetch(Statement) != SQL_NO_DATA)
-		ODBC_REPORT_ERROR("Data not expected");
+	CHKFetch("No");
 
-	if (SQLMoreResults(Statement) != SQL_NO_DATA)
-		ODBC_REPORT_ERROR("Not expected another recordset");
+	CHKMoreResults("No");
 
 	/* test that skipping a no empty result go to other result set */
 	Command(Statement, "insert into #odbctestdata values(123)");
 	if (!prepared) {
 		Command(Statement, "select * from #odbctestdata select * from #odbctestdata");
 	} else {
-		CHK(SQLPrepare, (Statement, (SQLCHAR *)"select * from #odbctestdata select * from #odbctestdata", SQL_NTS));
-		CHK(SQLExecute, (Statement));
+		CHKPrepare((SQLCHAR *)"select * from #odbctestdata select * from #odbctestdata", SQL_NTS, "S");
+		CHKExecute("S");
 	}
 
-	CHK(SQLMoreResults, (Statement));
+	CHKMoreResults("S");
 	printf("Getting next recordset\n");
 
-	CHK(SQLFetch, (Statement));
+	CHKFetch("S");
 
-	if (SQLFetch(Statement) != SQL_NO_DATA)
-		ODBC_REPORT_ERROR("Data not expected");
+	CHKFetch("No");
 
-	if (SQLMoreResults(Statement) != SQL_NO_DATA)
-		ODBC_REPORT_ERROR("Not expected another recordset");
+	CHKMoreResults("No");
 
 	Command(Statement, "drop table #odbctestdata");
 }
diff --git a/src/odbc/unittests/t0004.c b/src/odbc/unittests/t0004.c
index 839fa60..2a4093d 100644
--- a/src/odbc/unittests/t0004.c
+++ b/src/odbc/unittests/t0004.c
@@ -2,7 +2,7 @@
 
 /* Test for SQLMoreResults */
 
-static char software_version[] = "$Id: t0004.c,v 1.16 2008/01/29 14:30:49 freddy77 Exp $";
+static char software_version[] = "$Id: t0004.c,v 1.17 2008/11/04 10:59:02 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static void
@@ -15,39 +15,27 @@ Test(int use_indicator)
 	strcpy(buf, "I don't exist");
 	ind = strlen(buf);
 
-	CHK(SQLBindParameter, (Statement, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_VARCHAR, 20, 0, buf, 128, pind));
+	CHKBindParameter(1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_VARCHAR, 20, 0, buf, 128, pind, "S");
 
-	CHK(SQLPrepare, (Statement, (SQLCHAR *) "SELECT id, name FROM master..sysobjects WHERE name = ?", SQL_NTS));
+	CHKPrepare((SQLCHAR *) "SELECT id, name FROM master..sysobjects WHERE name = ?", SQL_NTS, "S");
 
-	CHK(SQLExecute, (Statement));
+	CHKExecute("S");
 
-	if (SQLFetch(Statement) != SQL_NO_DATA) {
-		fprintf(stderr, "Data not expected\n");
-		exit(1);
-	}
+	CHKFetch("No");
 
-	if (SQLMoreResults(Statement) != SQL_NO_DATA) {
-		fprintf(stderr, "Not expected another recordset\n");
-		exit(1);
-	}
+	CHKMoreResults("No");
 
 	/* use same binding above */
 	strcpy(buf, "sysobjects");
 	ind = strlen(buf);
 
-	CHK(SQLExecute, (Statement));
+	CHKExecute("S");
 
-	CHK(SQLFetch, (Statement));
+	CHKFetch("S");
 
-	if (SQLFetch(Statement) != SQL_NO_DATA) {
-		fprintf(stderr, "Data not expected\n");
-		exit(1);
-	}
+	CHKFetch("No");
 
-	if (SQLMoreResults(Statement) != SQL_NO_DATA) {
-		fprintf(stderr, "Not expected another recordset\n");
-		exit(1);
-	}
+	CHKMoreResults("No");
 }
 
 int
diff --git a/src/odbc/unittests/tables.c b/src/odbc/unittests/tables.c
index 0f90c55..6595f9c 100644
--- a/src/odbc/unittests/tables.c
+++ b/src/odbc/unittests/tables.c
@@ -1,6 +1,6 @@
 #include "common.h"
 
-static char software_version[] = "$Id: tables.c,v 1.15 2008/10/29 09:33:50 freddy77 Exp $";
+static char software_version[] = "$Id: tables.c,v 1.16 2008/11/04 10:59:02 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 #ifdef WIN32
@@ -15,7 +15,7 @@ static void
 ReadCol(int i)
 {
 	strcpy(output, "NULL");
-	CHK(SQLGetData, (Statement, i, SQL_C_CHAR, output, sizeof(output), &cnamesize));
+	CHKGetData(i, SQL_C_CHAR, output, sizeof(output), &cnamesize, "S");
 }
 
 static void
@@ -35,14 +35,14 @@ TestName(int index, const char *expected_name)
 	} while(0)
 
 	/* retrieve with SQLDescribeCol */
-	CHK(SQLDescribeCol, (Statement, index, (SQLCHAR *) name, sizeof(name), &len, &type, NULL, NULL, NULL));
+	CHKDescribeCol(index, (SQLCHAR *) name, sizeof(name), &len, &type, NULL, NULL, NULL, "S");
 	NAME_TEST;
 
 	/* retrieve with SQLColAttribute */
-	CHK(SQLColAttribute, (Statement, index, SQL_DESC_NAME, name, sizeof(name), &len, NULL));
+	CHKColAttribute(index, SQL_DESC_NAME, name, sizeof(name), &len, NULL, "S");
 	if (db_is_microsoft())
 		NAME_TEST;
-	CHK(SQLColAttribute, (Statement, index, SQL_DESC_LABEL, name, sizeof(name), &len, NULL));
+	CHKColAttribute(index, SQL_DESC_LABEL, name, sizeof(name), &len, NULL, "S");
 	NAME_TEST;
 }
 
@@ -57,11 +57,11 @@ static void
 DoTest(const char *type, int row_returned)
 {
 	int table_len = SQL_NULL_DATA;
-	SQLRETURN ret;
+	SQLRETURN RetCode;
 	char table_buf[80];
 	int found = 0;
 
-#define PARAM(x) (SQLCHAR *) (x), (x) ? strlen(x) : SQL_NULL_DATA
+#define LEN(x) (x) ? strlen(x) : SQL_NULL_DATA
 
 	if (table) {
 		strcpy(table_buf, table);
@@ -70,11 +70,7 @@ DoTest(const char *type, int row_returned)
 	}
 
 	printf("Test type '%s' %s row\n", type ? type : "", row_returned ? "with" : "without");
-	if (!SQL_SUCCEEDED(SQLTables(Statement, PARAM(catalog), PARAM(schema), (SQLCHAR *) table_buf, table_len, PARAM(type)))) {
-		printf("Unable to execute statement\n");
-		CheckReturn();
-		exit(1);
-	}
+	CHKTables((SQLCHAR *) catalog, LEN(catalog), (SQLCHAR *) schema, LEN(schema), (SQLCHAR *) table_buf, table_len, (SQLCHAR *) type, LEN(type), "SI");
 
 	/* test column name (for DBD::ODBC) */
 	TestName(1, use_odbc_version3 || !driver_is_freetds() ? "TABLE_CAT" : "TABLE_QUALIFIER");
@@ -84,11 +80,7 @@ DoTest(const char *type, int row_returned)
 	TestName(5, "REMARKS");
 
 	if (row_returned) {
-		if (!SQL_SUCCEEDED(SQLFetch(Statement))) {
-			printf("Unable to fetch row\n");
-			CheckReturn();
-			exit(1);
-		}
+		CHKFetch("SI");
 
 		if (!expect) {
 			ReadCol(1);
@@ -114,8 +106,7 @@ DoTest(const char *type, int row_returned)
 		if (strcmp(output, expect) == 0)
 			found = 1;
 	}
-	ret = SQLFetch(Statement);
-	while (ret == SQL_SUCCESS && row_returned > 1) {
+	while (CHKFetch("SNo") == SQL_SUCCESS && row_returned > 1) {
 		if (expect) {
 			ReadCol(expect_col);
 			if (strcmp(output, expect) == 0)
@@ -123,12 +114,10 @@ DoTest(const char *type, int row_returned)
 		}
 		if (row_returned < 2)
 			break;
-		ret = SQLFetch(Statement);
 	}
 
-	if (ret != SQL_NO_DATA) {
+	if (RetCode != SQL_NO_DATA) {
 		printf("Unexpected data\n");
-		CheckReturn();
 		exit(1);
 	}
 
@@ -137,11 +126,7 @@ DoTest(const char *type, int row_returned)
 		exit(1);
 	}
 
-	if (!SQL_SUCCEEDED(SQLCloseCursor(Statement))) {
-		printf("Unable to close cursr\n");
-		CheckReturn();
-		exit(1);
-	}
+	CHKCloseCursor("SI");
 	expect = NULL;
 	expect_col = 3;
 }
diff --git a/src/odbc/unittests/test64.c b/src/odbc/unittests/test64.c
index 4078cd8..9a42ab7 100644
--- a/src/odbc/unittests/test64.c
+++ b/src/odbc/unittests/test64.c
@@ -1,7 +1,7 @@
 /* test win64 consistency */
 #include "common.h"
 
-static char software_version[] = "$Id: test64.c,v 1.5 2008/02/13 08:52:09 freddy77 Exp $";
+static char software_version[] = "$Id: test64.c,v 1.6 2008/11/04 10:59:02 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 /*
@@ -33,7 +33,7 @@ check_ipd_params(void)
 static void
 set_ipd_params1(SQLULEN *ptr)
 {
-	CHK(SQLSetStmtAttr,(Statement, SQL_ATTR_PARAMS_PROCESSED_PTR, ptr, 0));
+	CHKSetStmtAttr(SQL_ATTR_PARAMS_PROCESSED_PTR, ptr, 0, "S");
 }
 
 static void
@@ -100,8 +100,8 @@ test_params(void)
 		(*p)(&len);
 		check_ipd_params();
 
-		CHK(SQLSetStmtAttr, (Statement, SQL_ATTR_PARAMSET_SIZE, (void *) int2ptr(ARRAY_SIZE), 0));
-		CHK(SQLBindParameter, (Statement, 1, SQL_PARAM_INPUT, SQL_C_ULONG, SQL_INTEGER, 5, 0, ids, 0, id_lens));
+		CHKSetStmtAttr(SQL_ATTR_PARAMSET_SIZE, (void *) int2ptr(ARRAY_SIZE), 0, "S");
+		CHKBindParameter(1, SQL_PARAM_INPUT, SQL_C_ULONG, SQL_INTEGER, 5, 0, ids, 0, id_lens, "S");
 
 		Command(Statement, "INSERT INTO #tmp1(i) VALUES(?)");
 		SQLMoreResults(Statement);
@@ -150,7 +150,7 @@ check_ird_params(void)
 static void
 set_ird_params1(SQLULEN *ptr)
 {
-	CHK(SQLSetStmtAttr,(Statement, SQL_ATTR_ROWS_FETCHED_PTR, ptr, 0));
+	CHKSetStmtAttr(SQL_ATTR_ROWS_FETCHED_PTR, ptr, 0, "S");
 }
 
 static void
@@ -205,17 +205,17 @@ test_rows(void)
 			(*p)(&len);
 		check_ird_params();
 
-//		CHK(SQLSetStmtAttr, (Statement, SQL_ATTR_PARAMSET_SIZE, (void *) int2ptr(ARRAY_SIZE), 0));
-//		CHK(SQLBindParameter, (Statement, 1, SQL_PARAM_INPUT, SQL_C_ULONG, SQL_INTEGER, 5, 0, ids, 0, id_lens));
+//		CHKSetStmtAttr(SQL_ATTR_PARAMSET_SIZE, (void *) int2ptr(ARRAY_SIZE), 0, "S");
+//		CHKBindParameter(1, SQL_PARAM_INPUT, SQL_C_ULONG, SQL_INTEGER, 5, 0, ids, 0, id_lens, "S");
 
 		CHK(SQLBindCol, (Statement, 1, SQL_C_ULONG, ids, 0, id_lens));
 		if (*p) {
-			CHK(SQLSetStmtAttr, (Statement, SQL_ATTR_ROW_ARRAY_SIZE, (void *) int2ptr(ARRAY_SIZE), 0));
+			CHKSetStmtAttr(SQL_ATTR_ROW_ARRAY_SIZE, (void *) int2ptr(ARRAY_SIZE), 0, "S");
 
 			Command(Statement, "SELECT DISTINCT i FROM #tmp1");
 			SQLFetch(Statement);
 		} else {
-			CHK(SQLSetStmtAttr, (Statement, SQL_ROWSET_SIZE, (void *) int2ptr(ARRAY_SIZE), 0));
+			CHKSetStmtAttr(SQL_ROWSET_SIZE, (void *) int2ptr(ARRAY_SIZE), 0, "S");
 			Command(Statement, "SELECT DISTINCT i FROM #tmp1");
 			CHK(SQLExtendedFetch, (Statement, SQL_FETCH_NEXT, 0, &len, NULL));
 		}
diff --git a/src/odbc/unittests/testodbc.c b/src/odbc/unittests/testodbc.c
index 96c28f5..3cc3926 100644
--- a/src/odbc/unittests/testodbc.c
+++ b/src/odbc/unittests/testodbc.c
@@ -10,7 +10,7 @@
 
 #include "common.h"
 
-static char software_version[] = "$Id: testodbc.c,v 1.12 2008/02/08 10:20:23 freddy77 Exp $";
+static char software_version[] = "$Id: testodbc.c,v 1.13 2008/11/04 10:59:02 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 #ifdef DEBUG
@@ -138,11 +138,11 @@ TestRawODBCPreparedQuery(void)
 
 	strcpy((char *) queryString, "SELECT * FROM #Products WHERE SupplierID = ?");
 
-	CHK(SQLBindParameter, (Statement, 1, SQL_PARAM_INPUT, SQL_C_SSHORT, SQL_INTEGER, 0, 0, &supplierId, 0, &lenOrInd));
+	CHKBindParameter(1, SQL_PARAM_INPUT, SQL_C_SSHORT, SQL_INTEGER, 0, 0, &supplierId, 0, &lenOrInd, "S");
 
-	CHK(SQLPrepare, (Statement, queryString, SQL_NTS));
+	CHKPrepare(queryString, SQL_NTS, "S");
 
-	CHK(SQLExecute, (Statement));
+	CHKExecute("S");
 
 	count = 0;
 
@@ -209,9 +209,9 @@ TestRawODBCDirectQuery(void)
 
 	strcpy((char *) queryString, "SELECT * FROM #Products WHERE SupplierID = ?");
 
-	CHK(SQLBindParameter, (Statement, 1, SQL_PARAM_INPUT, SQL_C_SSHORT, SQL_INTEGER, 0, 0, &supplierId, 0, &lenOrInd));
+	CHKBindParameter(1, SQL_PARAM_INPUT, SQL_C_SSHORT, SQL_INTEGER, 0, 0, &supplierId, 0, &lenOrInd, "S");
 
-	CHK(SQLExecDirect, (Statement, queryString, SQL_NTS));
+	CHKExecDirect(queryString, SQL_NTS, "S");
 
 	count = 0;
 
@@ -291,7 +291,7 @@ TestRawODBCGuid(void)
 
 	strcpy((char *) (queryString), "INSERT INTO #pet( name, owner, species, sex, age ) \
                          VALUES ( 'Fang', 'Mike', 'dog', 'm', 12 );");
-	CHK(SQLExecDirect, (Statement, queryString, SQL_NTS));
+	CHKExecDirect(queryString, SQL_NTS, "S");
 
 	AB_PRINT(("Insert row 2"));
 
@@ -304,10 +304,10 @@ TestRawODBCGuid(void)
 
 	lenOrInd = 0;
 	age = 3;
-	CHK(SQLBindParameter, (Statement, 1, SQL_PARAM_INPUT, SQL_C_SSHORT, SQL_INTEGER, 0, 0, &age, 0, &lenOrInd));
+	CHKBindParameter(1, SQL_PARAM_INPUT, SQL_C_SSHORT, SQL_INTEGER, 0, 0, &age, 0, &lenOrInd, "S");
 
-	CHK(SQLExecDirect, (Statement, queryString, SQL_NTS));
-	CHK(SQLFreeStmt, (Statement, SQL_CLOSE));
+	CHKExecDirect(queryString, SQL_NTS, "S");
+	CHKFreeStmt(SQL_CLOSE, "S");
 
 	AB_PRINT(("Insert row 3"));
 	/*
@@ -319,8 +319,8 @@ TestRawODBCGuid(void)
 	lenOrInd = SQL_NTS;
 	strcpy((char *) (guid), "87654321-4321-4321-4321-123456789abc");
 
-	CHK(SQLBindParameter, (Statement, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_GUID, 0, 0, guid, 0, &lenOrInd));
-	CHK(SQLExecDirect, (Statement, queryString, SQL_NTS));
+	CHKBindParameter(1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_GUID, 0, 0, guid, 0, &lenOrInd, "S");
+	CHKExecDirect(queryString, SQL_NTS, "S");
 
 	AB_PRINT(("Insert row 4"));
 	/*
@@ -332,8 +332,8 @@ TestRawODBCGuid(void)
 	lenOrInd = SQL_NTS;
 	strcpy((char *) (guid), "1234abcd-abcd-abcd-abcd-123456789abc");
 
-	CHK(SQLBindParameter, (Statement, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_CHAR, 36, 0, guid, 0, &lenOrInd));
-	CHK(SQLExecDirect, (Statement, queryString, SQL_NTS));
+	CHKBindParameter(1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_CHAR, 36, 0, guid, 0, &lenOrInd, "S");
+	CHKExecDirect(queryString, SQL_NTS, "S");
 
 	AB_PRINT(("Insert row 5"));
 	/*
@@ -357,7 +357,7 @@ TestRawODBCGuid(void)
 	lenOrInd = 16;
 	strcpy((char *) (guid), "1234abcd-abcd-abcd-abcd-123456789abc");
 
-	CHK(SQLBindParameter, (Statement, 1, SQL_PARAM_INPUT, SQL_C_GUID, SQL_GUID, 16, 0, &sqlguid, 16, &lenOrInd));
+	CHKBindParameter(1, SQL_PARAM_INPUT, SQL_C_GUID, SQL_GUID, 16, 0, &sqlguid, 16, &lenOrInd, "S");
 	status = SQLExecDirect(Statement, queryString, SQL_NTS);
 	if (status != SQL_SUCCESS) {
 		AB_ERROR(("Insert row 5 failed"));
@@ -369,11 +369,11 @@ TestRawODBCGuid(void)
 	 */
 	AB_PRINT(("retrieving name and guid"));
 	strcpy((char *) (queryString), "SELECT name, guid FROM #pet");
-	CHK(SQLExecDirect, (Statement, queryString, SQL_NTS));
+	CHKExecDirect(queryString, SQL_NTS, "S");
 	while (SQLFetch(Statement) == SQL_SUCCESS) {
 		count++;
-		CHK(SQLGetData, (Statement, 1, SQL_CHAR, name, 20, 0));
-		CHK(SQLGetData, (Statement, 2, SQL_CHAR, guid, 37, 0));
+		CHKGetData(1, SQL_CHAR, name, 20, 0, "S");
+		CHKGetData(2, SQL_CHAR, guid, 37, 0, "S");
 
 		AB_PRINT(("name: %-10s guid: %s", name, guid));
 	}
@@ -382,8 +382,7 @@ TestRawODBCGuid(void)
 	 * Realloc cursor handle - (Windows ODBC considers it an invalid cursor
 	 * state if we try SELECT again).
 	 */
-	CHK(SQLFreeStmt, (Statement, SQL_CLOSE));
-	CHK(SQLAllocHandle, (SQL_HANDLE_STMT, Connection, &Statement));
+	ResetStatement();
 
 
 	/*
@@ -392,11 +391,11 @@ TestRawODBCGuid(void)
 
 	AB_PRINT(("retrieving name and guid again"));
 	strcpy((char *) (queryString), "SELECT name, guid FROM #pet");
-	CHK(SQLExecDirect, (Statement, queryString, SQL_NTS));
-	while (SQLFetch(Statement) == SQL_SUCCESS) {
+	CHKExecDirect(queryString, SQL_NTS, "S");
+	while (CHKFetch("SNo") == SQL_SUCCESS) {
 		count++;
-		CHK(SQLGetData, (Statement, 1, SQL_CHAR, name, 20, 0));
-		CHK(SQLGetData, (Statement, 2, SQL_GUID, &sqlguid, 16, 0));
+		CHKGetData(1, SQL_CHAR, name, 20, 0, "S");
+		CHKGetData(2, SQL_GUID, &sqlguid, 16, 0, "S");
 
 		AB_PRINT(("%-10s %08X-%04X-%04X-%02X%02X-%02X%02X%02X%02X%02X%02X",
 			  name,
@@ -410,8 +409,7 @@ TestRawODBCGuid(void)
 	 * Realloc cursor handle - (Windows ODBC considers it an invalid cursor
 	 * state if we try SELECT again).
 	 */
-	CHK(SQLFreeStmt, (Statement, SQL_CLOSE));
-	CHK(SQLAllocHandle, (SQL_HANDLE_STMT, Connection, &Statement));
+	ResetStatement();
 
 	/*
 	 * Now retrieve rows via stored procedure passing GUID as param.
@@ -422,12 +420,12 @@ TestRawODBCGuid(void)
 	lenOrInd = SQL_NTS;
 	strcpy((char *) (guid), "87654321-4321-4321-4321-123456789abc");
 
-	CHK(SQLBindParameter, (Statement, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_GUID, 0, 0, guid, 0, &lenOrInd));
-	CHK(SQLExecDirect, (Statement, queryString, SQL_NTS));
+	CHKBindParameter(1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_GUID, 0, 0, guid, 0, &lenOrInd, "S");
+	CHKExecDirect(queryString, SQL_NTS, "S");
 	while (SQLFetch(Statement) == SQL_SUCCESS) {
 		count++;
-		CHK(SQLGetData, (Statement, 1, SQL_CHAR, name, 20, 0));
-		CHK(SQLGetData, (Statement, 2, SQL_CHAR, guid, 37, 0));
+		CHKGetData(1, SQL_CHAR, name, 20, 0, "S");
+		CHKGetData(2, SQL_CHAR, guid, 37, 0, "S");
 
 		AB_PRINT(("%-10s %s", name, guid));
 	}
@@ -436,8 +434,7 @@ TestRawODBCGuid(void)
 	 * Realloc cursor handle - (Windows ODBC considers it an invalid cursor
 	 * state after a previous SELECT has occurred).
 	 */
-	CHK(SQLFreeStmt, (Statement, SQL_CLOSE));
-	CHK(SQLAllocHandle, (SQL_HANDLE_STMT, Connection, &Statement));
+	ResetStatement();
 
 	/* cleanup */
 	CommandWithResult(Statement, "DROP PROC GetGUIDRows");
diff --git a/src/odbc/unittests/timeout.c b/src/odbc/unittests/timeout.c
index f8a7ddf..5e86031 100644
--- a/src/odbc/unittests/timeout.c
+++ b/src/odbc/unittests/timeout.c
@@ -3,19 +3,19 @@
 
 /* Test timeout of query */
 
-static char software_version[] = "$Id: timeout.c,v 1.8 2008/01/29 14:30:49 freddy77 Exp $";
+static char software_version[] = "$Id: timeout.c,v 1.9 2008/11/04 10:59:02 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static void
 AutoCommit(int onoff)
 {
-	CHK(SQLSetConnectAttr, (Connection, SQL_ATTR_AUTOCOMMIT, int2ptr(onoff), 0));
+	CHKSetConnectAttr(SQL_ATTR_AUTOCOMMIT, int2ptr(onoff), 0, "S");
 }
 
 static void
 EndTransaction(SQLSMALLINT type)
 {
-	CHK(SQLEndTran, (SQL_HANDLE_DBC, Connection, type));
+	CHKEndTran(SQL_HANDLE_DBC, Connection, type, "S");
 }
 
 int
@@ -50,15 +50,13 @@ main(int argc, char *argv[])
 	Connect();
 
 	AutoCommit(SQL_AUTOCOMMIT_OFF);
-	CHK(SQLSetStmtAttr, (Statement, SQL_ATTR_QUERY_TIMEOUT, (SQLPOINTER) 2, 0));
+	CHKSetStmtAttr(SQL_ATTR_QUERY_TIMEOUT, (SQLPOINTER) 2, 0, "S");
 
 	i = 1;
-	CHK(SQLBindParameter, (Statement, 1, SQL_PARAM_INPUT, SQL_C_SLONG, SQL_INTEGER, 0, 0, &i, 0, NULL));
+	CHKBindParameter(1, SQL_PARAM_INPUT, SQL_C_SLONG, SQL_INTEGER, 0, 0, &i, 0, NULL, "S");
 
-	CHK(SQLPrepare, (Statement, (SQLCHAR *) "update test_timeout set t = 'bad' where n = ?", SQL_NTS));
-	ret = SQLExecute(Statement);
-	if (ret != SQL_ERROR)
-		ODBC_REPORT_ERROR("SQLExecute success ??");
+	CHKPrepare((SQLCHAR *) "update test_timeout set t = 'bad' where n = ?", SQL_NTS, "S");
+	CHKExecute("E");
 	EndTransaction(SQL_ROLLBACK);
 
 	/* TODO should return error S1T00 Timeout expired, test error message */
